var methodPartStart = 0;
var maxMethodPart = 100;
var methodPartCnt = '';

function hashchangeHandler() {
	var newHash = window.location.hash.substring(1);
	var data = JSON.parse(newHash);
	
	if (data.method && asc[data.method]) {		
		var ret = asc[data.method].apply(data.params ? data.params : []);		
		window.location = 'https://invokedmethod/'+encodeURIComponent(JSON.stringify(ret));
	}
};

function runMethod(method) {	
	var ret = null;
	if (asc[method]) {		
		var params = [];
		for(var i=1; i<arguments.length; i++) {			
			params.push(arguments[i]);
		}
   		ret = asc[method].apply(asc, params);
	}
	
	//ak je to dlhsie ako 500 znakov tak to potrebujeme rozsekat
	
	var cnt = JSON.stringify(ret);		
	methodPartStart = 0;
	methodPartCnt = cnt;
	sendMethodPart();	
}

function sendMethodPart() {
	var substr = methodPartCnt.substr(methodPartStart,maxMethodPart);
	
	methodPartStart += maxMethodPart;
	var url = methodPartCnt.length > methodPartStart ? 'https://invokedpart/' : 'https://invokedmethod/';	
	try {
		url += Base64.encode(unescape(encodeURIComponent(substr)));	
	} catch (e) {
		alert(e.message);
		return;
	}	
	window.location = url;	
	if (methodPartCnt.length>methodPartStart) {
		setTimeout(sendMethodPart,1);
	}	
}

var locationCounter = 0;
function runFlexMethod(method, params) {
	locationCounter++;	
	var ret = {
		method: method,
		params: params,
		locationCounter: locationCounter
	}
	var str = 'https://flexmethod/'+Base64.encode(JSON.stringify(ret));
	
	window.location = str;
}

var asc = {};
asc.submitForm = function(id) {	
	var formElem = document.getElementById(id);
	if (!formElem) return {};	
	var data = {};
	for (var i=0;i<formElem.elements.length;i++) {
		var elem = formElem.elements[i];		
		data[elem.name] = elem.value;
	}
	
	return data;
}
asc.elementContent = function(id) {	
	var formElem = document.getElementById(id);
	if (!formElem) return '';	
	var ret = {
		'content': formElem.innerHTML
	}	
	return ret;
}

asc.loadCssStr = function(cnt) {
	var elem=document.createElement("style")    
    elem.setAttribute("type", "text/css");
    elem.innerHTML = cnt;
    document.getElementsByTagName("head")[0].appendChild(elem);    
}

asc.setElementBackgroundUrl = function(id, url) {	
	var elem = document.getElementById(id);
	
	if (!elem) {		
		return;
	}
	elem.style.backgroundImage = "url('"+url+"')";
}

asc.FastButton = function(element, handler) {
  if (element.hasFastButton) return;
  this.element = element;
  this.handler = handler;

  element.addEventListener('touchstart', this, false);
  element.addEventListener('click', this, false);
  element.hasFastButton = true;
};

asc.FastButton.prototype.handleEvent = function(event) {
  switch (event.type) {
    case 'touchstart': this.onTouchStart(event); break;    
    case 'touchmove': this.onTouchMove(event); break;    
    case 'touchend': this.onClick(event); break;
    case 'click': this.onClick(event); break;
  }
};

asc.FastButton.prototype.onTouchStart = function(event) {
  event.stopPropagation();

  this.element.addEventListener('touchend', this, false);
  document.body.addEventListener('touchmove', this, false);

  this.element.classList.toggle('fastbutton-active', true);
  this.startX = event.touches[0].clientX;
  this.startY = event.touches[0].clientY;
};

asc.FastButton.prototype.onTouchMove = function(event) {
  if (Math.abs(event.touches[0].clientX - this.startX) > 10 ||
      Math.abs(event.touches[0].clientY - this.startY) > 10) {
    this.reset();
    this.element.classList.remove('fastbutton-active');
  }
};

asc.FastButton.prototype.onClick = function(event) {
  event.stopPropagation();
  this.reset();  
  var self = this;
  self.handler.call(self, event);
  self.element.classList.remove('fastbutton-active');

  if (event.type == 'touchend') {
    asc.clickbuster.preventGhostClick(this.startX, this.startY);
  }
};

asc.FastButton.prototype.reset = function() {
  this.element.removeEventListener('touchend', this, false);
  document.body.removeEventListener('touchmove', this, false);
};
asc.clickbuster = function() {
}
asc.clickbuster.preventGhostClick = function(x, y) {
  asc.clickbuster.coordinates.push(x, y);
  window.setTimeout(asc.clickbuster.pop, 2500);
};

asc.clickbuster.pop = function() {
  asc.clickbuster.coordinates.splice(0, 2);
};

asc.clickbuster.onClick = function(event) {
  for (var i = 0; i < asc.clickbuster.coordinates.length; i += 2) {
    var x = asc.clickbuster.coordinates[i];
    var y = asc.clickbuster.coordinates[i + 1];
    if (Math.abs(event.clientX - x) < 25 && Math.abs(event.clientY - y) < 25) {
      event.stopPropagation();
      event.preventDefault();
    }
  }
};

asc.initDocument = function() {
	document.addEventListener('click', asc.clickbuster.onClick, true);
	asc.clickbuster.coordinates = [];
	
	var buttons = document.getElementsByClassName('fastbutton');
	for (var i=0;i<buttons.length;i++) {
		new asc.FastButton(buttons[i], function(event) {
			
			event.preventDefault();
			event.stopPropagation();
			var action = this.element.getAttribute('data-action');
			var location = this.element.getAttribute('data-location');
			
			if (location) {				
				window.location = location;
				return;
			}
			if (action) {				
				eval(action);				
				return;
			}			
			var href = this.element.getAttribute('href');			
			if (href) {				
				window.location = href;
				return;
			}
		});
	}
	
	this.initVideos();
}

asc.initVideos = function() {
	var iframes = document.querySelectorAll('iframe');
	
	for (var i=0;i<iframes.length;i++) {
		var iframe = iframes[i];
		var ratio = iframe.offsetHeight == 0 ? 16/9 : iframe.offsetWidth / iframe.offsetHeight;
		iframe.aspectRatio = ratio;
		 
		iframe.removeAttribute('width');
		iframe.removeAttribute('height');
		
		iframe.classList.toggle('videoIframe', true);
		
		iframe.parentNode.classList.toggle('videoWrapper', true);
	}
}

var Base64 = {
	// private property
	_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
	
	// public method for encoding
	encode : function (input) {
		if (typeof btoa == 'function') return btoa(input);
	    var output = "";
	    var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
	    var i = 0;
	
	    input = Base64._utf8_encode(input);
	
	    while (i < input.length) {
	
	        chr1 = input.charCodeAt(i++);
	        chr2 = input.charCodeAt(i++);
	        chr3 = input.charCodeAt(i++);
	
	        enc1 = chr1 >> 2;
	        enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
	        enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
	        enc4 = chr3 & 63;
	
	        if (isNaN(chr2)) {
	            enc3 = enc4 = 64;
	        } else if (isNaN(chr3)) {
	            enc4 = 64;
	        }
	
	        output = output +
	        this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
	        this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
	
	    }
	
	    return output;
	},
	
	// public method for decoding
	decode : function (input) {
		if (atob) return atob(input);
	    var output = "";
	    var chr1, chr2, chr3;
	    var enc1, enc2, enc3, enc4;
	    var i = 0;
	
	    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	
	    while (i < input.length) {
	
	        enc1 = this._keyStr.indexOf(input.charAt(i++));
	        enc2 = this._keyStr.indexOf(input.charAt(i++));
	        enc3 = this._keyStr.indexOf(input.charAt(i++));
	        enc4 = this._keyStr.indexOf(input.charAt(i++));
	
	        chr1 = (enc1 << 2) | (enc2 >> 4);
	        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
	        chr3 = ((enc3 & 3) << 6) | enc4;
	
	        output = output + String.fromCharCode(chr1);
	
	        if (enc3 != 64) {
	            output = output + String.fromCharCode(chr2);
	        }
	        if (enc4 != 64) {
	            output = output + String.fromCharCode(chr3);
	        }
	
	    }
	
	    output = Base64._utf8_decode(output);
	
	    return output;
	
	},
	
	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
	    string = string.replace(/\r\n/g,"\n");
	    var utftext = "";
	
	    for (var n = 0; n < string.length; n++) {
	
	        var c = string.charCodeAt(n);
	
	        if (c < 128) {
	            utftext += String.fromCharCode(c);
	        }
	        else if((c > 127) && (c < 2048)) {
	            utftext += String.fromCharCode((c >> 6) | 192);
	            utftext += String.fromCharCode((c & 63) | 128);
	        }
	        else {
	            utftext += String.fromCharCode((c >> 12) | 224);
	            utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	            utftext += String.fromCharCode((c & 63) | 128);
	        }
	
	    }
	
	    return utftext;
	},
	
	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
	    var string = "";
	    var i = 0;
	    var c = c1 = c2 = 0;
	
	    while ( i < utftext.length ) {
	
	        c = utftext.charCodeAt(i);
	
	        if (c < 128) {
	            string += String.fromCharCode(c);
	            i++;
	        }
	        else if((c > 191) && (c < 224)) {
	            c2 = utftext.charCodeAt(i+1);
	            string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	            i += 2;
	        }
	        else {
	            c2 = utftext.charCodeAt(i+1);
	            c3 = utftext.charCodeAt(i+2);
	            string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	            i += 3;
	        }
	
	    }
	
	    return string;
	}
}